uninstall.sh 30 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762
  1. #!/bin/bash
  2. # Author: yeho <lj2007331 AT gmail.com>
  3. # BLOG: https://linuxeye.com
  4. #
  5. # Notes: OneinStack for CentOS/RedHat 6+ Debian 8+ and Ubuntu 14+
  6. #
  7. # Project home page:
  8. # https://oneinstack.com
  9. # https://github.com/oneinstack/oneinstack
  10. export PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin
  11. clear
  12. printf "
  13. #######################################################################
  14. # OneinStack for CentOS/RedHat 6+ Debian 8+ and Ubuntu 14+ #
  15. # Uninstall OneinStack #
  16. # For more information please visit https://oneinstack.com #
  17. #######################################################################
  18. "
  19. # Check if user is root
  20. [ $(id -u) != "0" ] && { echo "${CFAILURE}Error: You must be root to run this script${CEND}"; exit 1; }
  21. oneinstack_dir=$(dirname "`readlink -f $0`")
  22. pushd ${oneinstack_dir} > /dev/null
  23. . ./options.conf
  24. . ./include/color.sh
  25. . ./include/get_char.sh
  26. . ./include/check_dir.sh
  27. Show_Help() {
  28. echo
  29. echo "Usage: $0 command ...[parameters]....
  30. --help, -h Show this help message, More: https://oneinstack.com
  31. --quiet, -q quiet operation
  32. --all Uninstall All
  33. --web Uninstall Nginx/Tengine/OpenResty/Apache/Tomcat
  34. --mysql Uninstall MySQL/MariaDB/Percona/AliSQL
  35. --postgresql Uninstall PostgreSQL
  36. --mongodb Uninstall MongoDB
  37. --php Uninstall PHP (PATH: ${php_install_dir})
  38. --mphp_ver [53~73] Uninstall another PHP version (PATH: ${php_install_dir}\${mphp_ver})
  39. --allphp Uninstall all PHP
  40. --phpcache Uninstall PHP opcode cache
  41. --php_extensions [ext name] Uninstall PHP extensions, include zendguardloader,ioncube,
  42. sourceguardian,imagick,gmagick,fileinfo,imap,ldap,calendar,phalcon,
  43. yaf,yar,redis,memcached,memcache,mongodb,swoole,xdebug
  44. --hhvm Uninstall HHVM
  45. --pureftpd Uninstall PureFtpd
  46. --redis Uninstall Redis-server
  47. --memcached Uninstall Memcached-server
  48. --phpmyadmin Uninstall phpMyAdmin
  49. --python Uninstall Python (PATH: ${python_install_dir})
  50. "
  51. }
  52. ARG_NUM=$#
  53. TEMP=`getopt -o hvVq --long help,version,quiet,all,web,mysql,postgresql,mongodb,php,mphp_ver:,allphp,phpcache,php_extensions:,hhvm,pureftpd,redis,memcached,phpmyadmin,python -- "$@" 2>/dev/null`
  54. [ $? != 0 ] && echo "${CWARNING}ERROR: unknown argument! ${CEND}" && Show_Help && exit 1
  55. eval set -- "${TEMP}"
  56. while :; do
  57. [ -z "$1" ] && break;
  58. case "$1" in
  59. -h|--help)
  60. Show_Help; exit 0
  61. ;;
  62. -q|--quiet)
  63. quiet_flag=y
  64. uninstall_flag=y
  65. shift 1
  66. ;;
  67. --all)
  68. all_flag=y
  69. web_flag=y
  70. mysql_flag=y
  71. postgresql_flag=y
  72. mongodb_flag=y
  73. allphp_flag=y
  74. hhvm_flag=y
  75. pureftpd_flag=y
  76. redis_flag=y
  77. memcached_flag=y
  78. phpmyadmin_flag=y
  79. python_flag=y
  80. shift 1
  81. ;;
  82. --web)
  83. web_flag=y; shift 1
  84. ;;
  85. --mysql)
  86. mysql_flag=y; shift 1
  87. ;;
  88. --postgresql)
  89. postgresql_flag=y; shift 1
  90. ;;
  91. --mongodb)
  92. mongodb_flag=y; shift 1
  93. ;;
  94. --php)
  95. php_flag=y; shift 1
  96. ;;
  97. --mphp_ver)
  98. mphp_ver=$2; mphp_flag=y; shift 2
  99. [[ ! "${mphp_ver}" =~ ^5[3-6]$|^7[0-3]$ ]] && { echo "${CWARNING}mphp_ver input error! Please only input number 53~73${CEND}"; exit 1; }
  100. ;;
  101. --allphp)
  102. allphp_flag=y; shift 1
  103. ;;
  104. --phpcache)
  105. phpcache_flag=y; shift 1
  106. ;;
  107. --php_extensions)
  108. php_extensions=$2; shift 2
  109. [ -n "`echo ${php_extensions} | grep -w zendguardloader`" ] && pecl_zendguardloader=1
  110. [ -n "`echo ${php_extensions} | grep -w ioncube`" ] && pecl_ioncube=1
  111. [ -n "`echo ${php_extensions} | grep -w sourceguardian`" ] && pecl_sourceguardian=1
  112. [ -n "`echo ${php_extensions} | grep -w imagick`" ] && pecl_imagick=1
  113. [ -n "`echo ${php_extensions} | grep -w gmagick`" ] && pecl_gmagick=1
  114. [ -n "`echo ${php_extensions} | grep -w fileinfo`" ] && pecl_fileinfo=1
  115. [ -n "`echo ${php_extensions} | grep -w imap`" ] && pecl_imap=1
  116. [ -n "`echo ${php_extensions} | grep -w ldap`" ] && pecl_ldap=1
  117. [ -n "`echo ${php_extensions} | grep -w calendar`" ] && pecl_calendar=1
  118. [ -n "`echo ${php_extensions} | grep -w phalcon`" ] && pecl_phalcon=1
  119. [ -n "`echo ${php_extensions} | grep -w yaf`" ] && pecl_yaf=1
  120. [ -n "`echo ${php_extensions} | grep -w yar`" ] && pecl_yar=1
  121. [ -n "`echo ${php_extensions} | grep -w redis`" ] && pecl_redis=1
  122. [ -n "`echo ${php_extensions} | grep -w memcached`" ] && pecl_memcached=1
  123. [ -n "`echo ${php_extensions} | grep -w memcache`" ] && pecl_memcache=1
  124. [ -n "`echo ${php_extensions} | grep -w mongodb`" ] && pecl_mongodb=1
  125. [ -n "`echo ${php_extensions} | grep -w swoole`" ] && pecl_swoole=1
  126. [ -n "`echo ${php_extensions} | grep -w xdebug`" ] && pecl_xdebug=1
  127. ;;
  128. --hhvm)
  129. hhvm_flag=y; shift 1
  130. ;;
  131. --pureftpd)
  132. pureftpd_flag=y; shift 1
  133. ;;
  134. --redis)
  135. redis_flag=y; shift 1
  136. ;;
  137. --memcached)
  138. memcached_flag=y; shift 1
  139. ;;
  140. --phpmyadmin)
  141. phpmyadmin_flag=y; shift 1
  142. ;;
  143. --python)
  144. python_flag=y; shift 1
  145. ;;
  146. --)
  147. shift
  148. ;;
  149. *)
  150. echo "${CWARNING}ERROR: unknown argument! ${CEND}" && Show_Help && exit 1
  151. ;;
  152. esac
  153. done
  154. Uninstall_status() {
  155. if [ "${quiet_flag}" != 'y' ]; then
  156. while :; do echo
  157. read -e -p "Do you want to uninstall? [y/n]: " uninstall_flag
  158. if [[ ! ${uninstall_flag} =~ ^[y,n]$ ]]; then
  159. echo "${CWARNING}input error! Please only input 'y' or 'n'${CEND}"
  160. else
  161. break
  162. fi
  163. done
  164. fi
  165. }
  166. Print_Warn() {
  167. echo
  168. echo "${CWARNING}You will uninstall OneinStack, Please backup your configure files and DB data! ${CEND}"
  169. }
  170. Print_web() {
  171. [ -d "${nginx_install_dir}" ] && echo ${nginx_install_dir}
  172. [ -d "${tengine_install_dir}" ] && echo ${tengine_install_dir}
  173. [ -d "${openresty_install_dir}" ] && echo ${openresty_install_dir}
  174. [ -e "/etc/init.d/nginx" ] && echo /etc/init.d/nginx
  175. [ -e "/lib/systemd/system/nginx.service" ] && echo /lib/systemd/system/nginx.service
  176. [ -e "/etc/logrotate.d/nginx" ] && echo /etc/logrotate.d/nginx
  177. [ -d "${apache_install_dir}" ] && echo ${apache_install_dir}
  178. [ -e "/lib/systemd/system/httpd.service" ] && echo /lib/systemd/system/httpd.service
  179. [ -e "/etc/init.d/httpd" ] && echo /etc/init.d/httpd
  180. [ -e "/etc/logrotate.d/apache" ] && echo /etc/logrotate.d/apache
  181. [ -d "${tomcat_install_dir}" ] && echo ${tomcat_install_dir}
  182. [ -e "/etc/init.d/tomcat" ] && echo /etc/init.d/tomcat
  183. [ -e "/etc/logrotate.d/tomcat" ] && echo /etc/logrotate.d/tomcat
  184. [ -d "/usr/java" ] && echo /usr/java
  185. [ -d "/usr/local/apr" ] && echo /usr/local/apr
  186. }
  187. Uninstall_Web() {
  188. [ -d "${nginx_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${nginx_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${nginx_install_dir}/sbin:@@" /etc/profile; echo "${CMSG}Nginx uninstall completed! ${CEND}"; }
  189. [ -d "${tengine_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${tengine_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${tengine_install_dir}/sbin:@@" /etc/profile; echo "${CMSG}Tengine uninstall completed! ${CEND}"; }
  190. [ -d "${openresty_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${openresty_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${openresty_install_dir}/nginx/sbin:@@" /etc/profile; echo "${CMSG}OpenResty uninstall completed! ${CEND}"; }
  191. [ -e "/lib/systemd/system/nginx.service" ] && { systemctl disable nginx > /dev/null 2>&1; rm -f /lib/systemd/system/nginx.service; }
  192. [ -d "${apache_install_dir}" ] && { service httpd stop > /dev/null 2>&1; rm -rf ${apache_install_dir} /etc/init.d/httpd /etc/logrotate.d/apache; sed -i "s@${apache_install_dir}/bin:@@" /etc/profile; echo "${CMSG}Apache uninstall completed! ${CEND}"; }
  193. [ -e "/lib/systemd/system/httpd.service" ] && { systemctl disable httpd > /dev/null 2>&1; rm -f /lib/systemd/system/httpd.service; }
  194. [ -d "${tomcat_install_dir}" ] && { killall java > /dev/null 2>&1; chmod +x /etc/logrotate.d/tomcat; rm -rf ${tomcat_install_dir} /etc/init.d/tomcat /etc/logrotate.d/tomcat /usr/local/apr; echo "${CMSG}Tomcat uninstall completed! ${CEND}"; }
  195. [ -d "/usr/java" ] && { rm -rf /usr/java; sed -i '/export JAVA_HOME=/d' /etc/profile; sed -i '/export CLASSPATH=/d' /etc/profile; sed -i 's@\$JAVA_HOME/bin:@@' /etc/profile; }
  196. [ -e "${wwwroot_dir}" ] && /bin/mv ${wwwroot_dir}{,$(date +%Y%m%d%H)}
  197. sed -i 's@^website_name=.*@website_name=@' ./options.conf
  198. sed -i 's@^backup_content=.*@backup_content=@' ./options.conf
  199. }
  200. Print_MySQL() {
  201. [ -e "${db_install_dir}" ] && echo ${db_install_dir}
  202. [ -e "/etc/init.d/mysqld" ] && echo /etc/init.d/mysqld
  203. [ -e "/etc/my.cnf" ] && echo /etc/my.cnf
  204. }
  205. Print_PostgreSQL() {
  206. [ -e "${pgsql_install_dir}" ] && echo ${pgsql_install_dir}
  207. [ -e "/etc/init.d/postgresql" ] && echo /etc/init.d/postgresql
  208. [ -e "/lib/systemd/system/postgresql.service" ] && echo /lib/systemd/system/postgresql.service
  209. }
  210. Print_MongoDB() {
  211. [ -e "${mongo_install_dir}" ] && echo ${mongo_install_dir}
  212. [ -e "/etc/init.d/mongod" ] && echo /etc/init.d/mongod
  213. [ -e "/lib/systemd/system/mongod.service" ] && echo /lib/systemd/system/mongod.service
  214. [ -e "/etc/mongod.conf" ] && echo /etc/mongod.conf
  215. }
  216. Uninstall_MySQL() {
  217. # uninstall mysql,mariadb,percona,alisql
  218. if [ -d "${db_install_dir}/support-files" ]; then
  219. service mysqld stop > /dev/null 2>&1
  220. rm -rf ${db_install_dir} /etc/init.d/mysqld /etc/my.cnf* /etc/ld.so.conf.d/*{mysql,mariadb,percona,alisql}*.conf
  221. id -u mysql >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel mysql
  222. [ -e "${db_data_dir}" ] && /bin/mv ${db_data_dir}{,$(date +%Y%m%d%H)}
  223. sed -i 's@^dbrootpwd=.*@dbrootpwd=@' ./options.conf
  224. sed -i "s@${db_install_dir}/bin:@@" /etc/profile
  225. echo "${CMSG}MySQL uninstall completed! ${CEND}"
  226. fi
  227. }
  228. Uninstall_PostgreSQL() {
  229. # uninstall postgresql
  230. if [ -e "${pgsql_install_dir}/bin/psql" ]; then
  231. service postgresql stop > /dev/null 2>&1
  232. rm -rf ${pgsql_install_dir} /etc/init.d/postgresql
  233. [ -e "/lib/systemd/system/postgresql.service" ] && { systemctl disable postgresql > /dev/null 2>&1; rm -f /lib/systemd/system/postgresql.service; }
  234. [ -e "${php_install_dir}/etc/php.d/07-pgsql.ini" ] && rm -f ${php_install_dir}/etc/php.d/07-pgsql.ini
  235. id -u postgres >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel postgres
  236. [ -e "${pgsql_data_dir}" ] && /bin/mv ${pgsql_data_dir}{,$(date +%Y%m%d%H)}
  237. sed -i 's@^dbpostgrespwd=.*@dbpostgrespwd=@' ./options.conf
  238. sed -i "s@${pgsql_install_dir}/bin:@@" /etc/profile
  239. echo "${CMSG}PostgreSQL uninstall completed! ${CEND}"
  240. fi
  241. }
  242. Uninstall_MongoDB() {
  243. # uninstall mongodb
  244. if [ -e "${mongo_install_dir}/bin/mongo" ]; then
  245. service mongod stop > /dev/null 2>&1
  246. rm -rf ${mongo_install_dir} /etc/mongod.conf /etc/init.d/mongod /tmp/mongo*.sock
  247. [ -e "/lib/systemd/system/mongod.service" ] && { systemctl disable mongod > /dev/null 2>&1; rm -f /lib/systemd/system/mongod.service; }
  248. [ -e "${php_install_dir}/etc/php.d/07-mongo.ini" ] && rm -f ${php_install_dir}/etc/php.d/07-mongo.ini
  249. [ -e "${php_install_dir}/etc/php.d/07-mongodb.ini" ] && rm -f ${php_install_dir}/etc/php.d/07-mongodb.ini
  250. id -u mongod > /dev/null 2>&1 ; [ $? -eq 0 ] && userdel mongod
  251. [ -e "${mongo_data_dir}" ] && /bin/mv ${mongo_data_dir}{,$(date +%Y%m%d%H)}
  252. sed -i 's@^dbmongopwd=.*@dbmongopwd=@' ./options.conf
  253. sed -i "s@${mongo_install_dir}/bin:@@" /etc/profile
  254. echo "${CMSG}MongoDB uninstall completed! ${CEND}"
  255. fi
  256. }
  257. Print_PHP() {
  258. [ -e "${php_install_dir}" ] && echo ${php_install_dir}
  259. [ -e "/etc/init.d/php-fpm" ] && echo /etc/init.d/php-fpm
  260. [ -e "/lib/systemd/system/php-fpm.service" ] && echo /lib/systemd/system/php-fpm.service
  261. }
  262. Print_MPHP() {
  263. [ -e "${php_install_dir}${mphp_ver}" ] && echo ${php_install_dir}${mphp_ver}
  264. [ -e "/etc/init.d/php${mphp_ver}-fpm" ] && echo /etc/init.d/php${mphp_ver}-fpm
  265. [ -e "/lib/systemd/system/php${mphp_ver}-fpm.service" ] && echo /lib/systemd/system/php${mphp_ver}-fpm.service
  266. }
  267. Print_ALLPHP() {
  268. [ -e "${php_install_dir}" ] && echo ${php_install_dir}
  269. [ -e "/etc/init.d/php-fpm" ] && echo /etc/init.d/php-fpm
  270. [ -e "/lib/systemd/system/php-fpm.service" ] && echo /lib/systemd/system/php-fpm.service
  271. for php_ver in 53 54 55 56 70 71 72 73; do
  272. [ -e "${php_install_dir}${php_ver}" ] && echo ${php_install_dir}${php_ver}
  273. [ -e "/etc/init.d/php${php_ver}-fpm" ] && echo /etc/init.d/php${php_ver}-fpm
  274. [ -e "/lib/systemd/system/php${php_ver}-fpm.service" ] && echo /lib/systemd/system/php${php_ver}-fpm.service
  275. done
  276. [ -e "${imagick_install_dir}" ] && echo ${imagick_install_dir}
  277. [ -e "${gmagick_install_dir}" ] && echo ${gmagick_install_dir}
  278. [ -e "${curl_install_dir}" ] && echo ${curl_install_dir}
  279. [ -e "${freetype_install_dir}" ] && echo ${freetype_install_dir}
  280. }
  281. Uninstall_PHP() {
  282. [ -e "/etc/init.d/php-fpm" ] && { service php-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php-fpm; }
  283. [ -e "/lib/systemd/system/php-fpm.service" ] && { systemctl stop php-fpm > /dev/null 2>&1; systemctl disable php-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php-fpm.service; }
  284. [ -e "${apache_install_dir}/conf/httpd.conf" ] && [ -n "`grep libphp ${apache_install_dir}/conf/httpd.conf`" ] && sed -i '/libphp/d' ${apache_install_dir}/conf/httpd.conf
  285. [ -e "${php_install_dir}" ] && { rm -rf ${php_install_dir}; echo "${CMSG}PHP uninstall completed! ${CEND}"; }
  286. sed -i "s@${php_install_dir}/bin:@@" /etc/profile
  287. }
  288. Uninstall_MPHP() {
  289. [ -e "/etc/init.d/php${mphp_ver}-fpm" ] && { service php${mphp_ver}-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php${mphp_ver}-fpm; }
  290. [ -e "/lib/systemd/system/php${mphp_ver}-fpm.service" ] && { systemctl stop php${mphp_ver}-fpm > /dev/null 2>&1; systemctl disable php${mphp_ver}-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php${mphp_ver}-fpm.service; }
  291. [ -e "${php_install_dir}${mphp_ver}" ] && { rm -rf ${php_install_dir}${mphp_ver}; echo "${CMSG}PHP${mphp_ver} uninstall completed! ${CEND}"; }
  292. }
  293. Uninstall_ALLPHP() {
  294. [ -e "/etc/init.d/php-fpm" ] && { service php-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php-fpm; }
  295. [ -e "/lib/systemd/system/php-fpm.service" ] && { systemctl stop php-fpm > /dev/null 2>&1; systemctl disable php-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php-fpm.service; }
  296. [ -e "${apache_install_dir}/conf/httpd.conf" ] && [ -n "`grep libphp ${apache_install_dir}/conf/httpd.conf`" ] && sed -i '/libphp/d' ${apache_install_dir}/conf/httpd.conf
  297. [ -e "${php_install_dir}" ] && { rm -rf ${php_install_dir}; echo "${CMSG}PHP uninstall completed! ${CEND}"; }
  298. sed -i "s@${php_install_dir}/bin:@@" /etc/profile
  299. for php_ver in 53 54 55 56 70 71 72 73; do
  300. [ -e "/etc/init.d/php${php_ver}-fpm" ] && { service php${php_ver}-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php${php_ver}-fpm; }
  301. [ -e "/lib/systemd/system/php${php_ver}-fpm.service" ] && { systemctl stop php${php_ver}-fpm > /dev/null 2>&1; systemctl disable php${php_ver}-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php${php_ver}-fpm.service; }
  302. [ -e "${php_install_dir}${php_ver}" ] && { rm -rf ${php_install_dir}${php_ver}; echo "${CMSG}PHP${php_ver} uninstall completed! ${CEND}"; }
  303. done
  304. [ -e "${imagick_install_dir}" ] && rm -rf ${imagick_install_dir}
  305. [ -e "${gmagick_install_dir}" ] && rm -rf ${gmagick_install_dir}
  306. [ -e "${curl_install_dir}" ] && rm -rf ${curl_install_dir}
  307. [ -e "${freetype_install_dir}" ] && rm -rf ${freetype_install_dir}
  308. }
  309. Uninstall_PHPcache() {
  310. . include/zendopcache.sh
  311. . include/xcache.sh
  312. . include/apcu.sh
  313. . include/eaccelerator.sh
  314. Uninstall_ZendOPcache
  315. Uninstall_XCache
  316. Uninstall_APCU
  317. Uninstall_eAccelerator
  318. # reload php
  319. [ -e "${php_install_dir}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php-fpm || service php-fpm reload; }
  320. [ -n "${mphp_ver}" -a -e "${php_install_dir}${mphp_ver}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php${mphp_ver}-fpm || service php${mphp_ver}-fpm reload; }
  321. [ -e "${apache_install_dir}/bin/apachectl" ] && ${apache_install_dir}/bin/apachectl -k graceful
  322. }
  323. Uninstall_PHPext() {
  324. # ZendGuardLoader
  325. if [ "${pecl_zendguardloader}" == '1' ]; then
  326. . include/ZendGuardLoader.sh
  327. Uninstall_ZendGuardLoader
  328. fi
  329. # ioncube
  330. if [ "${pecl_ioncube}" == '1' ]; then
  331. . include/ioncube.sh
  332. Uninstall_ionCube
  333. fi
  334. # SourceGuardian
  335. if [ "${pecl_sourceguardian}" == '1' ]; then
  336. . include/sourceguardian.sh
  337. Uninstall_SourceGuardian
  338. fi
  339. # imagick
  340. if [ "${pecl_imagick}" == '1' ]; then
  341. . include/ImageMagick.sh
  342. Uninstall_ImageMagick
  343. Uninstall_pecl_imagick
  344. fi
  345. # gmagick
  346. if [ "${pecl_gmagick}" == '1' ]; then
  347. . include/GraphicsMagick.sh
  348. Uninstall_GraphicsMagick
  349. Uninstall_pecl_gmagick
  350. fi
  351. # fileinfo
  352. if [ "${pecl_fileinfo}" == '1' ]; then
  353. . include/pecl_fileinfo.sh
  354. Uninstall_pecl_fileinfo
  355. fi
  356. # imap
  357. if [ "${pecl_imap}" == '1' ]; then
  358. . include/pecl_imap.sh
  359. Uninstall_pecl_imap
  360. fi
  361. # ldap
  362. if [ "${pecl_ldap}" == '1' ]; then
  363. . include/pecl_ldap.sh
  364. Uninstall_pecl_ldap
  365. fi
  366. # calendar
  367. if [ "${pecl_calendar}" == '1' ]; then
  368. . include/pecl_calendar.sh
  369. Uninstall_pecl_calendar
  370. fi
  371. # phalcon
  372. if [ "${pecl_phalcon}" == '1' ]; then
  373. . include/pecl_phalcon.sh
  374. Uninstall_pecl_phalcon
  375. fi
  376. # yaf
  377. if [ "${pecl_yaf}" == '1' ]; then
  378. . include/pecl_yaf.sh
  379. Uninstall_pecl_yaf 2>&1 | tee -a ${oneinstack_dir}/install.log
  380. fi
  381. # yar
  382. if [ "${pecl_yar}" == '1' ]; then
  383. . include/pecl_yar.sh
  384. Uninstall_pecl_yar 2>&1 | tee -a ${oneinstack_dir}/install.log
  385. fi
  386. # pecl_memcached
  387. if [ "${pecl_memcached}" == '1' ]; then
  388. . include/memcached.sh
  389. Uninstall_pecl_memcached
  390. fi
  391. # pecl_memcache
  392. if [ "${pecl_memcache}" == '1' ]; then
  393. . include/memcached.sh
  394. Uninstall_pecl_memcache
  395. fi
  396. # pecl_redis
  397. if [ "${pecl_redis}" == '1' ]; then
  398. . include/redis.sh
  399. Uninstall_pecl_redis
  400. fi
  401. # pecl_mongodb
  402. if [ "${pecl_mongodb}" == '1' ]; then
  403. . include/pecl_mongodb.sh
  404. Uninstall_pecl_mongodb
  405. fi
  406. # swoole
  407. if [ "${pecl_swoole}" == '1' ]; then
  408. . include/pecl_swoole.sh
  409. Uninstall_pecl_swoole
  410. fi
  411. # xdebug
  412. if [ "${pecl_xdebug}" == '1' ]; then
  413. . include/pecl_xdebug.sh
  414. Uninstall_pecl_xdebug
  415. fi
  416. # reload php
  417. [ -e "${php_install_dir}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php-fpm || service php-fpm reload; }
  418. [ -n "${mphp_ver}" -a -e "${php_install_dir}${mphp_ver}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php${mphp_ver}-fpm || service php${mphp_ver}-fpm reload; }
  419. [ -e "${apache_install_dir}/bin/apachectl" ] && ${apache_install_dir}/bin/apachectl -k graceful
  420. }
  421. Menu_PHPext() {
  422. while :; do
  423. echo 'Please select uninstall PHP extensions:'
  424. echo -e "\t${CMSG} 0${CEND}. Do not uninstall"
  425. echo -e "\t${CMSG} 1${CEND}. Uninstall zendguardloader(PHP<=5.6)"
  426. echo -e "\t${CMSG} 2${CEND}. Uninstall ioncube"
  427. echo -e "\t${CMSG} 3${CEND}. Uninstall sourceguardian(PHP<=7.2)"
  428. echo -e "\t${CMSG} 4${CEND}. Uninstall imagick"
  429. echo -e "\t${CMSG} 5${CEND}. Uninstall gmagick"
  430. echo -e "\t${CMSG} 6${CEND}. Uninstall fileinfo"
  431. echo -e "\t${CMSG} 7${CEND}. Uninstall imap"
  432. echo -e "\t${CMSG} 8${CEND}. Uninstall ldap"
  433. echo -e "\t${CMSG} 9${CEND}. Uninstall phalcon(PHP>=5.5)"
  434. echo -e "\t${CMSG}10${CEND}. Uninstall redis"
  435. echo -e "\t${CMSG}11${CEND}. Uninstall memcached"
  436. echo -e "\t${CMSG}12${CEND}. Uninstall memcache"
  437. echo -e "\t${CMSG}13${CEND}. Uninstall mongodb"
  438. echo -e "\t${CMSG}14${CEND}. Uninstall swoole"
  439. echo -e "\t${CMSG}15${CEND}. Uninstall xdebug(PHP>=5.5)"
  440. read -e -p "Please input a number:(Default 0 press Enter) " phpext_option
  441. phpext_option=${phpext_option:-0}
  442. [ "${phpext_option}" == '0' ] && break
  443. array_phpext=(${phpext_option})
  444. array_all=(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15)
  445. for v in ${array_phpext[@]}
  446. do
  447. [ -z "`echo ${array_all[@]} | grep -w ${v}`" ] && phpext_flag=1
  448. done
  449. if [ "${phpext_flag}" == '1' ]; then
  450. unset phpext_flag
  451. echo; echo "${CWARNING}input error! Please only input number 1 2 3 14 and so on${CEND}"; echo
  452. continue
  453. else
  454. [ -n "`echo ${array_phpext[@]} | grep -w 1`" ] && pecl_zendguardloader=1
  455. [ -n "`echo ${array_phpext[@]} | grep -w 2`" ] && pecl_ioncube=1
  456. [ -n "`echo ${array_phpext[@]} | grep -w 3`" ] && pecl_sourceguardian=1
  457. [ -n "`echo ${array_phpext[@]} | grep -w 4`" ] && pecl_imagick=1
  458. [ -n "`echo ${array_phpext[@]} | grep -w 5`" ] && pecl_gmagick=1
  459. [ -n "`echo ${array_phpext[@]} | grep -w 6`" ] && pecl_fileinfo=1
  460. [ -n "`echo ${array_phpext[@]} | grep -w 7`" ] && pecl_imap=1
  461. [ -n "`echo ${array_phpext[@]} | grep -w 8`" ] && pecl_ldap=1
  462. [ -n "`echo ${array_phpext[@]} | grep -w 9`" ] && pecl_phalcon=1
  463. [ -n "`echo ${array_phpext[@]} | grep -w 10`" ] && pecl_redis=1
  464. [ -n "`echo ${array_phpext[@]} | grep -w 11`" ] && pecl_memcached=1
  465. [ -n "`echo ${array_phpext[@]} | grep -w 12`" ] && pecl_memcache=1
  466. [ -n "`echo ${array_phpext[@]} | grep -w 13`" ] && pecl_mongodb=1
  467. [ -n "`echo ${array_phpext[@]} | grep -w 14`" ] && pecl_swoole=1
  468. [ -n "`echo ${array_phpext[@]} | grep -w 15`" ] && pecl_xdebug=1
  469. break
  470. fi
  471. done
  472. }
  473. Print_HHVM() {
  474. [ -e "/usr/bin/hhvm" ] && echo /usr/bin/hhvm
  475. [ -e "/etc/hhvm" ] && echo /etc/hhvm
  476. [ -e "/var/log/hhvm" ] && echo /var/log/hhvm
  477. [ -e "/lib/systemd/system/hhvm.service" ] && echo /lib/systemd/system/hhvm.service
  478. [ -e "/etc/supervisord.conf" ] && echo /etc/supervisord.conf
  479. [ -e "/etc/init.d/supervisord" ] && echo /etc/init.d/supervisord
  480. }
  481. Uninstall_HHVM() {
  482. [ -e "/lib/systemd/system/hhvm.service" ] && { systemctl disable hhvm > /dev/null 2>&1; rm -f /lib/systemd/system/hhvm.service; }
  483. [ -e "/etc/init.d/supervisord" ] && { service supervisord stop > /dev/null 2>&1; rm -f /etc/supervisord.conf /etc/init.d/supervisord; }
  484. [ -e "/usr/bin/hhvm" ] && { rpm -e hhvm; rm -rf /etc/hhvm /var/log/hhvm /usr/bin/hhvm; echo "${CMSG}HHVM uninstall completed! ${CEND}"; }
  485. }
  486. Print_PureFtpd() {
  487. [ -e "${pureftpd_install_dir}" ] && echo ${pureftpd_install_dir}
  488. [ -e "/etc/init.d/pureftpd" ] && echo /etc/init.d/pureftpd
  489. [ -e "/lib/systemd/system/pureftpd.service" ] && echo /lib/systemd/system/pureftpd.service
  490. }
  491. Uninstall_PureFtpd() {
  492. [ -e "${pureftpd_install_dir}" ] && { service pureftpd stop > /dev/null 2>&1; rm -rf ${pureftpd_install_dir} /etc/init.d/pureftpd; echo "${CMSG}Pureftpd uninstall completed! ${CEND}"; }
  493. [ -e "/lib/systemd/system/pureftpd.service" ] && { systemctl disable pureftpd > /dev/null 2>&1; rm -f /lib/systemd/system/pureftpd.service; }
  494. }
  495. Print_Redis_server() {
  496. [ -e "${redis_install_dir}" ] && echo ${redis_install_dir}
  497. [ -e "/etc/init.d/redis-server" ] && echo /etc/init.d/redis-server
  498. [ -e "/lib/systemd/system/redis-server.service" ] && echo /lib/systemd/system/redis-server.service
  499. }
  500. Uninstall_Redis_server() {
  501. [ -e "${redis_install_dir}" ] && { service redis-server stop > /dev/null 2>&1; rm -rf ${redis_install_dir} /etc/init.d/redis-server /usr/local/bin/redis-*; echo "${CMSG}Redis uninstall completed! ${CEND}"; }
  502. [ -e "/lib/systemd/system/redis-server.service" ] && { systemctl disable redis-server > /dev/null 2>&1; rm -f /lib/systemd/system/redis-server.service; }
  503. }
  504. Print_Memcached_server() {
  505. [ -e "${memcached_install_dir}" ] && echo ${memcached_install_dir}
  506. [ -e "/etc/init.d/memcached" ] && echo /etc/init.d/memcached
  507. [ -e "/usr/bin/memcached" ] && echo /usr/bin/memcached
  508. }
  509. Uninstall_Memcached_server() {
  510. [ -e "${memcached_install_dir}" ] && { service memcached stop > /dev/null 2>&1; rm -rf ${memcached_install_dir} /etc/init.d/memcached /usr/bin/memcached; echo "${CMSG}Memcached uninstall completed! ${CEND}"; }
  511. }
  512. Print_phpMyAdmin() {
  513. [ -d "${wwwroot_dir}/default/phpMyAdmin" ] && echo ${wwwroot_dir}/default/phpMyAdmin
  514. }
  515. Uninstall_phpMyAdmin() {
  516. [ -d "${wwwroot_dir}/default/phpMyAdmin" ] && rm -rf ${wwwroot_dir}/default/phpMyAdmin
  517. }
  518. Print_openssl() {
  519. [ -d "${openssl_install_dir}" ] && echo ${openssl_install_dir}
  520. }
  521. Uninstall_openssl() {
  522. [ -d "${openssl_install_dir}" ] && rm -rf ${openssl_install_dir}
  523. }
  524. Print_Python() {
  525. [ -d "${python_install_dir}" ] && echo ${python_install_dir}
  526. }
  527. Menu() {
  528. while :; do
  529. printf "
  530. What Are You Doing?
  531. \t${CMSG} 0${CEND}. Uninstall All
  532. \t${CMSG} 1${CEND}. Uninstall Nginx/Tengine/OpenResty/Apache/Tomcat
  533. \t${CMSG} 2${CEND}. Uninstall MySQL/MariaDB/Percona/AliSQL
  534. \t${CMSG} 3${CEND}. Uninstall PostgreSQL
  535. \t${CMSG} 4${CEND}. Uninstall MongoDB
  536. \t${CMSG} 5${CEND}. Uninstall all PHP
  537. \t${CMSG} 6${CEND}. Uninstall PHP opcode cache
  538. \t${CMSG} 7${CEND}. Uninstall PHP extensions
  539. \t${CMSG} 8${CEND}. Uninstall HHVM
  540. \t${CMSG} 9${CEND}. Uninstall PureFtpd
  541. \t${CMSG}10${CEND}. Uninstall Redis
  542. \t${CMSG}11${CEND}. Uninstall Memcached
  543. \t${CMSG}12${CEND}. Uninstall phpMyAdmin
  544. \t${CMSG}13${CEND}. Uninstall Python (PATH: ${python_install_dir})
  545. \t${CMSG} q${CEND}. Exit
  546. "
  547. echo
  548. read -e -p "Please input the correct option: " Number
  549. if [[ ! "${Number}" =~ ^[0-9,q]$|^1[0-3]$ ]]; then
  550. echo "${CWARNING}input error! Please only input 0~13 and q${CEND}"
  551. else
  552. case "$Number" in
  553. 0)
  554. Print_Warn
  555. Print_web
  556. Print_MySQL
  557. Print_PostgreSQL
  558. Print_MongoDB
  559. Print_ALLPHP
  560. Print_HHVM
  561. Print_PureFtpd
  562. Print_Redis_server
  563. Print_Memcached_server
  564. Print_openssl
  565. Print_phpMyAdmin
  566. Print_Python
  567. Uninstall_status
  568. if [ "${uninstall_flag}" == 'y' ]; then
  569. Uninstall_Web
  570. Uninstall_MySQL
  571. Uninstall_PostgreSQL
  572. Uninstall_MongoDB
  573. Uninstall_ALLPHP
  574. Uninstall_HHVM
  575. Uninstall_PureFtpd
  576. Uninstall_Redis_server
  577. Uninstall_Memcached_server
  578. Uninstall_openssl
  579. Uninstall_phpMyAdmin
  580. . include/python.sh; Uninstall_Python
  581. else
  582. exit
  583. fi
  584. ;;
  585. 1)
  586. Print_Warn
  587. Print_web
  588. Uninstall_status
  589. [ "${uninstall_flag}" == 'y' ] && Uninstall_Web || exit
  590. ;;
  591. 2)
  592. Print_Warn
  593. Print_MySQL
  594. Uninstall_status
  595. [ "${uninstall_flag}" == 'y' ] && Uninstall_MySQL || exit
  596. ;;
  597. 3)
  598. Print_Warn
  599. Print_PostgreSQL
  600. Uninstall_status
  601. [ "${uninstall_flag}" == 'y' ] && Uninstall_PostgreSQL || exit
  602. ;;
  603. 4)
  604. Print_Warn
  605. Print_MongoDB
  606. Uninstall_status
  607. [ "${uninstall_flag}" == 'y' ] && Uninstall_MongoDB || exit
  608. ;;
  609. 5)
  610. Print_ALLPHP
  611. Uninstall_status
  612. [ "${uninstall_flag}" == 'y' ] && Uninstall_ALLPHP || exit
  613. ;;
  614. 6)
  615. Uninstall_status
  616. [ "${uninstall_flag}" == 'y' ] && Uninstall_PHPcache || exit
  617. ;;
  618. 7)
  619. Menu_PHPext
  620. [ "${phpext_option}" != '0' ] && Uninstall_status
  621. [ "${uninstall_flag}" == 'y' ] && Uninstall_PHPext || exit
  622. ;;
  623. 8)
  624. Print_HHVM
  625. Uninstall_status
  626. [ "${uninstall_flag}" == 'y' ] && Uninstall_HHVM || exit
  627. ;;
  628. 9)
  629. Print_PureFtpd
  630. Uninstall_status
  631. [ "${uninstall_flag}" == 'y' ] && Uninstall_PureFtpd || exit
  632. ;;
  633. 10)
  634. Print_Redis_server
  635. Uninstall_status
  636. [ "${uninstall_flag}" == 'y' ] && Uninstall_Redis_server || exit
  637. ;;
  638. 11)
  639. Print_Memcached_server
  640. Uninstall_status
  641. [ "${uninstall_flag}" == 'y' ] && Uninstall_Memcached_server || exit
  642. ;;
  643. 12)
  644. Print_phpMyAdmin
  645. Uninstall_status
  646. [ "${uninstall_flag}" == 'y' ] && Uninstall_phpMyAdmin || exit
  647. ;;
  648. 13)
  649. Print_Python
  650. Uninstall_status
  651. [ "${uninstall_flag}" == 'y' ] && { . include/python.sh; Uninstall_Python; } || exit
  652. ;;
  653. q)
  654. exit
  655. ;;
  656. esac
  657. fi
  658. done
  659. }
  660. if [ ${ARG_NUM} == 0 ]; then
  661. Menu
  662. else
  663. [ "${web_flag}" == 'y' ] && Print_web
  664. [ "${mysql_flag}" == 'y' ] && Print_MySQL
  665. [ "${postgresql_flag}" == 'y' ] && Print_PostgreSQL
  666. [ "${mongodb_flag}" == 'y' ] && Print_MongoDB
  667. if [ "${allphp_flag}" == 'y' ]; then
  668. Print_ALLPHP
  669. else
  670. [ "${php_flag}" == 'y' ] && Print_PHP
  671. [ "${mphp_flag}" == 'y' ] && [ "${phpcache_flag}" != 'y' ] && [ -z "${php_extensions}" ] && Print_MPHP
  672. fi
  673. [ "${hhvm_flag}" == 'y' ] && Print_HHVM
  674. [ "${pureftpd_flag}" == 'y' ] && Print_PureFtpd
  675. [ "${redis_flag}" == 'y' ] && Print_Redis_server
  676. [ "${memcached_flag}" == 'y' ] && Print_Memcached_server
  677. [ "${phpmyadmin_flag}" == 'y' ] && Print_phpMyAdmin
  678. [ "${python_flag}" == 'y' ] && Print_Python
  679. [ "${all_flag}" == 'y' ] && Print_openssl
  680. Uninstall_status
  681. if [ "${uninstall_flag}" == 'y' ]; then
  682. [ "${web_flag}" == 'y' ] && Uninstall_Web
  683. [ "${mysql_flag}" == 'y' ] && Uninstall_MySQL
  684. [ "${postgresql_flag}" == 'y' ] && Uninstall_PostgreSQL
  685. [ "${mongodb_flag}" == 'y' ] && Uninstall_MongoDB
  686. if [ "${allphp_flag}" == 'y' ]; then
  687. Uninstall_ALLPHP
  688. else
  689. [ "${php_flag}" == 'y' ] && Uninstall_PHP
  690. [ "${phpcache_flag}" == 'y' ] && Uninstall_PHPcache
  691. [ -n "${php_extensions}" ] && Uninstall_PHPext
  692. [ "${mphp_flag}" == 'y' ] && [ "${phpcache_flag}" != 'y' ] && [ -z "${php_extensions}" ] && Uninstall_MPHP
  693. [ "${mphp_flag}" == 'y' ] && [ "${phpcache_flag}" == 'y' ] && { php_install_dir=${php_install_dir}${mphp_ver}; Uninstall_PHPcache; }
  694. [ "${mphp_flag}" == 'y' ] && [ -n "${php_extensions}" ] && { php_install_dir=${php_install_dir}${mphp_ver}; Uninstall_PHPext; }
  695. fi
  696. [ "${hhvm_flag}" == 'y' ] && Uninstall_HHVM
  697. [ "${pureftpd_flag}" == 'y' ] && Uninstall_PureFtpd
  698. [ "${redis_flag}" == 'y' ] && Uninstall_Redis_server
  699. [ "${memcached_flag}" == 'y' ] && Uninstall_Memcached_server
  700. [ "${phpmyadmin_flag}" == 'y' ] && Uninstall_phpMyAdmin
  701. [ "${python_flag}" == 'y' ] && { . include/python.sh; Uninstall_Python; }
  702. [ "${all_flag}" == 'y' ] && Uninstall_openssl
  703. fi
  704. fi